package polynomial;

import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class PolynomialTest {
	
	private Polynomial p;

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		// runs before the class is constructed
		// we don't need it for this project
		// use it to get a database connection (for example)
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		// use this to destroy any objects constructed by the previous
	}

	@Before
	public void setUp() throws Exception {
		p = new Polynomial("x",Arrays.asList(2,3,4));
	}

	@After
	public void tearDown() throws Exception {
		p = null; //not necessary
	}

	//@Test
	//public void testPolynomial() {
	//	fail("Not yet implemented");
	//}

	@Test
	public void testAdd() {
		fail("Not yet implemented");
	}

	@Test
	public void testToString1() {
		
		String result = p.toString();
		assertEquals("Testing polynomial 2+3x+4x^2","2+3x1+4x2",result);
		
	}
	
	
	
	//@Test(expected=IndexOutOfBoundsException.class)
	//public void testException() {
		//List<Integer> test = new ArrayList<Integer>();
		//Polynomial q = new Polynomial("z",test);
	//}
	
	@Test
	public void testFindRoot() {
		double result = p.findRoot(1, 10);
		double eps = 0.01;
		assertEquals(2,result,eps);// result must be >2-eps, < 2+eps
	}
	
	@Test
	public void testReflectionMethodSetVarName() {
		try {
			Class<?> c = String.class;
			Class<?> v = void.class;
			Class<?> poly = Polynomial.class;
			Method m = poly.getMethod("setVarName", c);
			Type t = m.getGenericReturnType();
			assertTrue(t.equals(v));
		} catch (NoSuchMethodException e) {
			fail("The setVarName does exist or is private");
		}
	}

}
